#!/usr/bin/env python

# Locks: Minimal-Beispiel
# zwei Threads, zwei Locks (Mutexe)
# hge, 2023-12-15

from threading import Thread as create_thread, \
    Lock as create_mutex
from time import sleep
import logging

logging.basicConfig(level=logging.DEBUG,
                    format='(%(threadName)-12s) %(message)s',)

def lock(mutex):
    if mutex=="A":
        logging.debug("A locken")
        lockA.acquire()
    elif mutex=="B":
        logging.debug("B locken")
        lockB.acquire()

def unlock(mutex):
    if   mutex=="A": lockA.release()
    elif mutex=="B": lockB.release()

def worker1():
    lock("A"); sleep(0.01)  # Chance fuer Thread-Wechsel
    lock("B")
    logging.debug("Kritischer Bereich")
    unlock("A")
    unlock("B")

def worker2():
    lock("B"); sleep(0.01)  # Chance fuer Thread-Wechsel
    lock("A")
    logging.debug("Kritischer Bereich")
    unlock("A")
    unlock("B")

# Locks erzeugen
lockA = create_mutex()
lockB = create_mutex()
# Threads erzeugen
t1 = create_thread(target=worker1); t1.start()
t2 = create_thread(target=worker2); t2.start()
# Fertige Threads einsammeln
t1.join()
t2.join()
